Object subclass: #ObjectWithID
	instanceVariableNames: 'objectID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ObjectWithID methodsFor: 'accessing' stamp: 'JMV 7/9/1999 21:08'!
objectID

	^ objectID! !


!ObjectWithID methodsFor: 'eventos' stamp: 'JMV 7/14/1999 08:54'!
signalEvent: aSymbol withArguments: anArray
	"Tell interested parties."

	ClientManager current notifyInterestedParties: self objectID
		event: aSymbol
		withArguments: anArray.! !


!ObjectWithID methodsFor: 'initialize' stamp: 'JMV 7/22/1999 22:28'!
initialize

	objectID _ 'objectID:', self hash printString", Date today day printString, Time now print24"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ObjectWithID class
	instanceVariableNames: ''!

!ObjectWithID class methodsFor: 'instance creation' stamp: 'JMV 7/9/1999 21:04'!
new

	^ super new initialize! !


ObjectWithID subclass: #Language
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!
!Language commentStamp: '<historical>' prior: 0!
My instances are natural languages people speaks.!


!Language methodsFor: 'accessing' stamp: 'JMV 7/7/1999 19:56'!
name

	^ name! !

!Language methodsFor: 'accessing' stamp: 'JMV 7/11/1999 21:45'!
name: aString

	^ name _ aString! !


ObjectWithID subclass: #ScrabbleBoard
	instanceVariableNames: 'boxes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ScrabbleBoard methodsFor: 'initialize' stamp: 'JMV 7/16/1999 22:47'!
asignDefaultMultipliers

	| aSet |

	aSet _ Set new.
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x y: aPoint y) letterMultiplier: 2 ].

	aSet _ Set new.
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x y: aPoint y) letterMultiplier: 3 ].

	aSet _ Set new.
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x y: aPoint y) wordMultiplier: 2 ].

	aSet _ Set new.
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x y: aPoint y) wordMultiplier: 3 ].! !

!ScrabbleBoard methodsFor: 'initialize' stamp: 'JMV 7/16/1999 22:47'!
asignMultipliersExpanded

	| aSet excedent mult |
	excedent _ (self size - 15) / 2.

	"Prepara un board convencional en el centro"
	aSet _ Set new.
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumLetterBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x + excedent y: aPoint y + excedent) letterMultiplier: 2 ].

	aSet _ Set new.
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumLetterBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x + excedent y: aPoint y + excedent) letterMultiplier: 3 ].

	aSet _ Set new.
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumWordBoxes2 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x + excedent y: aPoint y + excedent) wordMultiplier: 2 ].

	aSet _ Set new.
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@1) + (16@0)].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (1@-1) + (0@16)].
	self class premiumWordBoxes3 do: [ :aPoint | aSet add: aPoint * (-1@-1) + (16@16)].
	aSet do: [ :aPoint | 
		(self boxAtX: aPoint x + excedent y: aPoint y + excedent) wordMultiplier: 3 ].

	1 to: excedent do: [ :i |
		1 to: 15+i do: [ :j |
			mult _ (self boxAtX: excedent-i+1+7 y: excedent+j) letterMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent-i+1 y: excedent+j) letterMultiplier: mult ].
			mult _ (self boxAtX: excedent-i+1+7 y: excedent+j) wordMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent-i+1 y: excedent+j) wordMultiplier: mult ].

			mult _ (self boxAtX: excedent+i+15-7 y: excedent+j) letterMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent+i+15 y: excedent+j) letterMultiplier: mult ].
			mult _ (self boxAtX: excedent+i+15-7 y: excedent+j) wordMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent+i+15 y: excedent+j) wordMultiplier: mult ].

			mult _ (self boxAtX: excedent+j y: excedent-i+1+7) letterMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent+j y: excedent-i+1) letterMultiplier: mult ].
			mult _ (self boxAtX: excedent+j y: excedent-i+1+7) wordMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent+j y: excedent-i+1) wordMultiplier: mult ].

			mult _ (self boxAtX: excedent+j y: excedent+i+15-7) letterMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent+j y: excedent+i+15) letterMultiplier: mult ].
			mult _ (self boxAtX: excedent+j y: excedent+i+15-7) wordMultiplier.
			mult > 1 ifTrue: [
				(self boxAtX: excedent+j y: excedent+i+15) wordMultiplier: mult ].
		].

		mult _ (self boxAtX: excedent-i+1 y: excedent-i+1+7) letterMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent-i+1 y: excedent-i+1) letterMultiplier: mult ].
		mult _ (self boxAtX: excedent-i+1 y: excedent-i+1+7) wordMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent-i+1 y: excedent-i+1) wordMultiplier: mult ].

		mult _ (self boxAtX: excedent+i+15 y: excedent-i+1+7) letterMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent+i+15 y: excedent-i+1) letterMultiplier: mult ].
		mult _ (self boxAtX: excedent+i+15 y: excedent-i+1+7) wordMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent+i+15 y: excedent-i+1) wordMultiplier: mult ].

		mult _ (self boxAtX: excedent-i+1 y: excedent+i+15-7) letterMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent-i+1 y: excedent+i+15) letterMultiplier: mult ].
		mult _ (self boxAtX: excedent-i+1 y: excedent+i+15-7) wordMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent-i+1 y: excedent+i+15) wordMultiplier: mult ].

		mult _ (self boxAtX: excedent+i+15 y: excedent+i+15-7) letterMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent+i+15 y: excedent+i+15) letterMultiplier: mult ].
		mult _ (self boxAtX: excedent+i+15 y: excedent+i+15-7) wordMultiplier.
		mult > 1 ifTrue: [
			(self boxAtX: excedent+i+15 y: excedent+i+15) wordMultiplier: mult ].
	].

	(self boxAtX: 1 y: 1) wordMultiplier: 3.
	(self boxAtX: self size y: 1) wordMultiplier: 3.
	(self boxAtX: 1 y: self size) wordMultiplier: 3.
	(self boxAtX: self size y: self size) wordMultiplier: 3.
	excedent > 3 ifTrue: [
		(self boxAtX: excedent+8 y: 1) wordMultiplier: 3.
		(self boxAtX: 1 y: excedent+8) wordMultiplier: 3.
		(self boxAtX: excedent+8 y: self size) wordMultiplier: 3.
		(self boxAtX: self size y: excedent+8) wordMultiplier: 3.
	].! !

!ScrabbleBoard methodsFor: 'initialize' stamp: 'JMV 7/15/1999 18:52'!
playerQty: aNumber
	"Inicialize an instance"

	| size |
	size _ aNumber <= 4 ifTrue: [ 15 ]
		ifFalse: [ (aNumber*225/16) sqrt truncated * 2 + 1 ].
	boxes _ Array new: size.
	1 to: size do: [ :x |
		boxes at: x put: (Array new: size) ].

	1 to: size do: [ :x |
		1 to: size do: [ :y |
			self boxAtX: x y: y put: ScrabbleBoardBox new ] ].

	size = 15 ifTrue: [
		self asignDefaultMultipliers ]
	ifFalse: [
		self asignMultipliersExpanded ].! !


!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/16/1999 22:45'!
areAlignedAndConnected: playData
	| minX maxX minY maxY occupied new old x y result |

	result _ true.
	minX _ nil.
	maxX _ nil.
	minY _ nil.
	maxY _ nil.
	occupied _ Set new.
	new _ Set new.
	old _ Set new.
	1 to: playData size / 3 do: [ :i |
		x _ (playData at: i*3-1) asNumber.
		y _ (playData at: i*3) asNumber.
		(minX isNil or: [x < minX]) ifTrue: [minX _ x].
		(maxX isNil or: [x > maxX]) ifTrue: [maxX _ x].
		(minY isNil or: [y < minY]) ifTrue: [minY _ y].
		(maxY isNil or: [y > maxY]) ifTrue: [maxY _ y].
		occupied add: (Point x: x y: y).
		new add: (Point x: x y: y).
	].

	1 to: self size do: [ :xx |
		1 to: self size do: [ :yy |
			(self boxAtX: xx y: yy) tile notNil ifTrue: [
				occupied add: (Point x: xx y: yy).
				old add: (Point x: xx y: yy). ] ] ].

	minX = maxX ifTrue: [
		minY to: maxY do: [ :yy |
			(occupied includes: (Point x: minX y: yy)) ifFalse: [
				result _ false ] ] ]	"Not in the same word (there are empty spaces)"
	ifFalse: [
		minY = maxY ifTrue: [
			minX to: maxX do: [ :xx |
				(occupied includes: (Point x: xx y: minY)) ifFalse: [
					result _ false ] ] ]	"Not in the same word (there are empty spaces)"
		ifFalse: [ result _ false ]].	"Not aligned"

	"Check that some old is adyacent to a new"
	old isEmpty ifFalse: [
		new detect: [ :each | 
				(old includes: (each + (1@0))) |
				(old includes: (each + (0@1))) |
				(old includes: (each - (1@0))) |
				(old includes: (each - (0@1))) ]
			ifNone: [result _ false] ].

	"Check first word in center"
	( old isEmpty and: [ 
		(new includes: (Point x: self size//2+1 y: self size//2+1)) not ] ) ifTrue: [
			result _ false ].
	^ result.! !

!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/16/1999 17:06'!
formedWords: playData
	"Get new formed words.
	If play goes horizontally, extend so a letter, and vertically all of them.
	If play goes vertically, extend so a letter, and horizontally all of them."

	| letters tile minX maxX minY maxY x y words word xs ys |

	words _ OrderedCollection new.
	letters _ Array new: self size.
	xs _ OrderedCollection new.
	ys _ OrderedCollection new.
	1 to: self size do: [ :xx |
		letters at: xx put: (Array new: self size) ].

	1 to: self size do: [ :xx |
		1 to: self size do: [ :yy |
			tile _ (self boxAtX: xx y: yy) tile.
			tile notNil ifTrue: [
				(letters at: xx) at: yy put: tile letter. ] ] ].

	minX _ nil.
	maxX _ nil.
	minY _ nil.
	maxY _ nil.
	1 to: playData size / 3 do: [ :i |
		x _ (playData at: i*3-1) asNumber.
		y _ (playData at: i*3) asNumber.
		(minX isNil or: [x < minX]) ifTrue: [minX _ x].
		(maxX isNil or: [x > maxX]) ifTrue: [maxX _ x].
		(minY isNil or: [y < minY]) ifTrue: [minY _ y].
		(maxY isNil or: [y > maxY]) ifTrue: [maxY _ y].
		xs add: x.
		ys add: y.
		tile _ ClientManager current convertToObject: (playData at: i*3-2).
		(letters at: x) at: y put: tile letter.
	].

	minX = maxX ifTrue: [
		word _ (self getVerticalWordIn: letters x: minX y: minY).
		word notNil ifTrue: [ words add: word ].
		ys do: [ :yy |
			word _ (self getHorizontalWordIn: letters x: minX y: yy). 
			word notNil ifTrue: [ words add: word ] ] ]
	ifFalse: [
		minY = maxY ifTrue: [
			word _ (self getHorizontalWordIn: letters x: minX y: minY).
			word notNil ifTrue: [ words add: word ].
			xs do: [ :xx |
				word _ (self getVerticalWordIn: letters x: xx y: minY). 
				word notNil ifTrue: [ words add: word ] ] ] ].
	^words! !

!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/16/1999 15:50'!
getHorizontalWordIn: anArray x: x y: y

	| start end answer |
	start _ x.
	end _ x.
	[ start > 1 and: [((anArray at: start-1) at: y) notNil ] ] whileTrue: [start _ start - 1].
	[ end < self size and: [((anArray at: end+1) at: y) notNil ] ] whileTrue: [end _ end + 1].
	start = end ifFalse: [
		answer _ ''.
		start to: end do: [ :i |
			answer _ answer, ((anArray at: i) at: y) asString ] ].
	^ answer
! !

!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/16/1999 15:51'!
getVerticalWordIn: anArray x: x y: y

	| start end answer |
	start _ y.
	end _ y.
	[ start > 1 and: [((anArray at: x) at: start-1) notNil ] ] whileTrue: [start _ start - 1].
	[ end < self size and: [((anArray at: x) at: end+1) notNil ] ] whileTrue: [end _ end + 1].
	start = end ifFalse: [
		answer _ ''.
		start to: end do: [ :i |
			answer _ answer, ((anArray at: x) at: i) asString ] ].
	^ answer! !

!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/24/1999 11:13'!
scoreForHorizontalPlayX: x y: y new: aCollectionOfPoints

	| start end score wordMultiplier |
	score _ 0.
	wordMultiplier _ 1.
	start _ x.
	end _ x.
	[ start > 1 and: [(self boxAtX: start-1 y: y) tile notNil ] ] whileTrue: [start _ start - 1].
	[ end < self size and: [(self boxAtX: end+1 y: y) tile notNil ] ] whileTrue: [end _ end + 1].
	start = end ifFalse: [
		start to: end do: [ :i |
			(aCollectionOfPoints includes: (i@y)) ifTrue: [
				wordMultiplier _ wordMultiplier * (self boxAtX: i y: y) wordMultiplier.
				score _ score + ((self boxAtX: i y: y) tile score * (self boxAtX: i y: y) letterMultiplier). ]
			ifFalse: [
				score _ score + (self boxAtX: i y: y) tile score. ].
		].
	].
	^ score * wordMultiplier! !

!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/24/1999 13:24'!
scoreForPlay: playData

	| scores minX maxX minY maxY x y xs ys playBoxes |

	scores _ 0.
	xs _ OrderedCollection new.
	ys _ OrderedCollection new.
	playBoxes _ OrderedCollection new.

	minX _ nil.
	maxX _ nil.
	minY _ nil.
	maxY _ nil.
	1 to: playData size / 3 do: [ :i |
		x _ (playData at: i*3-1) asNumber.
		y _ (playData at: i*3) asNumber.
		(minX isNil or: [x < minX]) ifTrue: [minX _ x].
		(maxX isNil or: [x > maxX]) ifTrue: [maxX _ x].
		(minY isNil or: [y < minY]) ifTrue: [minY _ y].
		(maxY isNil or: [y > maxY]) ifTrue: [maxY _ y].
		xs add: x.
		ys add: y.
		playBoxes add: (x@y).
	].

	minX = maxX ifTrue: [
		scores _ scores + 
			(self scoreForVerticalPlayX: minX y: minY new: playBoxes).
		ys do: [ :yy |
			scores _ scores + 
				(self scoreForHorizontalPlayX: minX y: yy new: playBoxes). 
			] ]
	ifFalse: [
		minY = maxY ifTrue: [
			scores _ scores + 
				(self scoreForHorizontalPlayX: minX y: minY new: playBoxes).
			xs do: [ :xx |
				scores _ scores + 
					(self scoreForVerticalPlayX: xx y: minY new: playBoxes). 
				] ] ].
	^ scores! !

!ScrabbleBoard methodsFor: 'validations' stamp: 'JMV 7/24/1999 11:24'!
scoreForVerticalPlayX: x y: y new: aCollectionOfPoints

	| start end score wordMultiplier |
	score _ 0.
	wordMultiplier _ 1.
	start _ y.
	end _ y.
	[ start > 1 and: [(self boxAtX: x y: start-1) tile notNil ] ] whileTrue: [start _ start - 1].
	[ end < self size and: [(self boxAtX: x y: end+1) tile notNil ] ] whileTrue: [end _ end + 1].
	start = end ifFalse: [
		start to: end do: [ :i |
			(aCollectionOfPoints includes: (x@i)) ifTrue: [
				wordMultiplier _ wordMultiplier * (self boxAtX: x y: i) wordMultiplier.
				score _ score + ((self boxAtX: x y: i) tile score * (self boxAtX: x y: i) letterMultiplier). ]
			ifFalse: [
				score _ score + (self boxAtX: x y: i) tile score. ].
		].
	].
	^ score * wordMultiplier! !


!ScrabbleBoard methodsFor: 'accessing' stamp: 'JMV 7/14/1999 20:01'!
boxAtX: x y: y

	^ (boxes at: x) at: y! !

!ScrabbleBoard methodsFor: 'accessing' stamp: 'JMV 7/14/1999 20:01'!
boxAtX: x y: y put: anObject

	^ (boxes at: x) at: y put: anObject! !

!ScrabbleBoard methodsFor: 'accessing' stamp: 'JMV 7/14/1999 19:57'!
size

	^ boxes size! !

!ScrabbleBoard methodsFor: 'accessing' stamp: 'JMV 7/24/1999 13:25'!
tiles

	| tiles tile |
	tiles _ OrderedCollection new.
	1 to: self size do: [ :xx |
		1 to: self size do: [ :yy |
			tile _ (self boxAtX: xx y: yy) tile.
			tile notNil ifTrue: [
				tiles add: tile ] ] ].
	^ tiles! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScrabbleBoard class
	instanceVariableNames: ''!

!ScrabbleBoard class methodsFor: 'inicialization defaults' stamp: 'JMV 7/14/1999 19:53'!
premiumLetterBoxes2
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (4@1). (1@4). (7@3). (3@7). (7@7). (4@8). (8@4)}! !

!ScrabbleBoard class methodsFor: 'inicialization defaults' stamp: 'JMV 7/14/1999 19:53'!
premiumLetterBoxes3
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (6@2). (2@6). (6@6) }! !

!ScrabbleBoard class methodsFor: 'inicialization defaults' stamp: 'JMV 7/14/1999 19:53'!
premiumWordBoxes2
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (2@2). (3@3). (4@4). (5@5). (8@8) }! !

!ScrabbleBoard class methodsFor: 'inicialization defaults' stamp: 'JMV 7/14/1999 19:53'!
premiumWordBoxes3
	"Answer the coordinates for premium squares in the first cuadrant."

	^ { (1@1). (1@8). (8@1) }! !


!ScrabbleBoard class methodsFor: 'instance creation' stamp: 'JMV 7/14/1999 20:30'!
newForPlayerQty: aNumber

	^ self new playerQty: aNumber! !


ObjectWithID subclass: #ScrabbleBoardBox
	instanceVariableNames: 'tile wordMultiplier letterMultiplier '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/14/1999 20:09'!
initialize
	"Inicialize an instance"

	super initialize.
	letterMultiplier _ 1.
	wordMultiplier _ 1.! !

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/14/1999 20:09'!
letterMultiplier

	^ letterMultiplier! !

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/14/1999 19:56'!
letterMultiplier: aNumber

	letterMultiplier _ aNumber.
	wordMultiplier _ 1.! !

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/16/1999 14:28'!
tile
	"Answer my tile, or nil if none."

	^ tile! !

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/16/1999 14:28'!
tile: aScrabbleTile
	"Set my tile"

	^ tile _ aScrabbleTile! !

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/14/1999 20:09'!
wordMultiplier

	^ wordMultiplier! !

!ScrabbleBoardBox methodsFor: 'accessing' stamp: 'JMV 7/14/1999 19:56'!
wordMultiplier: aNumber

	wordMultiplier _ aNumber.
	letterMultiplier _ 1.! !


ObjectWithID subclass: #ScrabbleDictionary
	instanceVariableNames: 'name language contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!
!ScrabbleDictionary commentStamp: '<historical>' prior: 0!
My instances are dictionaries for validating Scrabble words.!


!ScrabbleDictionary methodsFor: 'validacion' stamp: 'JMV 7/16/1999 17:16'!
isAValidWord: aString
	"Answer if aString is a valid word."

	^contents includes: aString asLowercase! !


!ScrabbleDictionary methodsFor: 'accessing' stamp: 'JMV 7/7/1999 20:14'!
language

	^ language! !

!ScrabbleDictionary methodsFor: 'accessing' stamp: 'JMV 7/7/1999 20:14'!
name

	^ name! !


!ScrabbleDictionary methodsFor: 'initialization' stamp: 'JMV 7/24/1999 09:35'!
importEnglishPartFromIDP: aFilename
	"Imports English words from an IDP dictionary file. Does not include the word in the other language.
	See the Internet Dictionary Project at: 
	This method still has to be tweaked."

	| aFile aLine aWord |
	aFile _ FileDirectory default readOnlyFileNamed: aFilename.
	aLine _ aFile upTo: Character cr.
	aFile next.
	'Reading Dictionary Data ' displayProgressAt: Sensor cursorPoint
		from: 0 to: aFile size
		during: [ :bar |
			[aFile atEnd] whileFalse: [
				(aLine size > 0 and: [((aLine at: 1) = $#) not]) ifTrue: [
					aLine substrings doWithIndex: [ :eachString :i | 
						(i = 1 ) ifTrue: [
							eachString _ eachString asLowercase.
							aWord _ eachString reject: [ :each | 
								(each < $a) & (each > $z) ].
							aWord size > 1 ifTrue: [
								contents add: aWord.
								"Transcript show: '|',aWord, '|';cr."
							].
						].
					].
				].
				aLine _ aFile upTo: Character cr.
				aFile next.
				bar value: aFile position.
			].
		].
	aFile close.! !

!ScrabbleDictionary methodsFor: 'initialization' stamp: 'JMV 3/26/2000 16:04'!
importFrom: aFilename
	"Imports from a simple dictionary file.
	This method still has to be tweaked."

	| aFile words |
	aFile _ FileDirectory default readOnlyFileNamed: aFilename.
	words _ aFile contentsOfEntireFile substrings.
	'Reading Dictionary Data '
		displayProgressAt: Sensor cursorPoint
		from: 0 to: words size
		during: [ :bar |
			words doWithIndex: [ :aWord :x |
				aWord _ aWord asLowercase.
				aWord size > 1 ifTrue: [
					contents add: aWord.
					"Transcript show: '|',aWord, '|';cr."
				].
				bar value: x.
			].
		].
	aFile close.! !

!ScrabbleDictionary methodsFor: 'initialization' stamp: 'JMV 7/24/1999 09:27'!
importFromDAT: aFilename
	"Imports from a DAT dictionary file.
	This method elliminates any accents or special character, except for $.
	This method still has to be tweaked."

	| aFile words |
	aFile _ FileDirectory default readOnlyFileNamed: aFilename.
	words _ aFile contentsOfEntireFile substrings.
	'Reading Dictionary Data ' displayProgressAt: Sensor cursorPoint
		from: 0 to: words size
		during: [ :bar |
				words doWithIndex: [ :aWord :x |
				1 to: aWord size do: [ :i |
					((aWord at: i) asciiValue = 225 ) ifTrue: [ aWord at: i put: $a.].
					((aWord at: i) asciiValue = 233 ) ifTrue: [ aWord at: i put: $e.].
					((aWord at: i) asciiValue = 234 ) ifTrue: [ aWord at: i put: $e.].
					((aWord at: i) asciiValue = 237 ) ifTrue: [ aWord at: i put: $i.].
					((aWord at: i) asciiValue = 243 ) ifTrue: [ aWord at: i put: $o.].
					((aWord at: i) asciiValue = 250 ) ifTrue: [ aWord at: i put: $u.].
					((aWord at: i) asciiValue = 252 ) ifTrue: [ aWord at: i put: $u.].
					((aWord at: i) asciiValue = 241 ) ifTrue: [ aWord at: i put: $.].
					((aWord at: i) asciiValue = 199 ) ifTrue: [ aWord at: i put: $c.].
					((aWord at: i) asciiValue = 231 ) ifTrue: [ aWord at: i put: $c.].
					((aWord at: i) asciiValue = 195 ) ifTrue: [ aWord at: i put: $a.].
					((aWord at: i) asciiValue = 227 ) ifTrue: [ aWord at: i put: $a.].
					((aWord at: i) = $[ ) ifTrue: [ aWord at: i put: $  .].
					((aWord at: i) = $~ and: [(aWord at: i-1) = $n]) ifTrue: [ aWord at: i-1 put: $.].
					((aWord at: i) = $, and: [(aWord at: i-1) = $c]) ifTrue: [ aWord at: i put: $/.].
					(((aWord at: i) = $.) | ((aWord at: i) = $,) | ((aWord at: i) = $-) ) ifTrue: [
						aWord at: i put: $  .].
				].
				aWord _ aWord asLowercase.
				aWord size > 1 ifTrue: [
					contents add: aWord.
					"Transcript show: '|',aWord, '|';cr."
				].
				bar value: x.
			].
		].
	aFile close.! !

!ScrabbleDictionary methodsFor: 'initialization' stamp: 'JMV 7/24/1999 09:34'!
importNonEnglishPartFromIDP: aFilename
	"Imports the NON-English words from an IDP dictionary file. Does not include the word in English.
	See the Internet Dictionary Project at: 
	This method elliminates any accents or special character, except for $.
	This method still has to be tweaked."

	| aFile aLine aWord |
	aFile _ FileDirectory default readOnlyFileNamed: aFilename.
	aLine _ aFile upTo: Character cr.
	aFile next.
	'Reading Dictionary Data ' displayProgressAt: Sensor cursorPoint
		from: 0 to: aFile size
		during: [ :bar |
			[aFile atEnd] whileFalse: [
				(aLine size > 0 and: [((aLine at: 1) = $#) not]) ifTrue: [
					1 to: aLine size do: [ :i |
						((aLine at: i) asciiValue = 225 ) ifTrue: [ aLine at: i put: $a.].
						((aLine at: i) asciiValue = 233 ) ifTrue: [ aLine at: i put: $e.].
						((aLine at: i) asciiValue = 234 ) ifTrue: [ aLine at: i put: $e.].
						((aLine at: i) asciiValue = 237 ) ifTrue: [ aLine at: i put: $i.].
						((aLine at: i) asciiValue = 243 ) ifTrue: [ aLine at: i put: $o.].
						((aLine at: i) asciiValue = 250 ) ifTrue: [ aLine at: i put: $u.].
						((aLine at: i) asciiValue = 252 ) ifTrue: [ aLine at: i put: $u.].
						((aLine at: i) asciiValue = 241 ) ifTrue: [ aLine at: i put: $.].
						((aLine at: i) asciiValue = 199 ) ifTrue: [ aLine at: i put: $c.].
						((aLine at: i) asciiValue = 231 ) ifTrue: [ aLine at: i put: $c.].
						((aLine at: i) asciiValue = 195 ) ifTrue: [ aLine at: i put: $a.].
						((aLine at: i) asciiValue = 227 ) ifTrue: [ aLine at: i put: $a.].
						((aLine at: i) = $[ ) ifTrue: [ aLine at: i put: $  .].
						((aLine at: i) = $~ and: [(aLine at: i-1) = $n]) ifTrue: [ aLine at: i-1 put: $.].
						((aLine at: i) = $, and: [(aLine at: i-1) = $c]) ifTrue: [ aLine at: i put: $/.].
						(((aLine at: i) = $.) | ((aLine at: i) = $,) | ((aLine at: i) = $-) ) ifTrue: [
							aLine at: i put: $  .].
					].
					aLine substrings doWithIndex: [ :eachString :i | 
						(i > 1 & (eachString includes: $]) not &
						(eachString includes: $( ) not  &
						(eachString includes: $) ) not ) ifTrue: [
							eachString _ eachString asLowercase.
							aWord _ eachString reject: [ :each | 
								(each < $a) & (each > $z) & (each ~= $) ].
							aWord size > 1 ifTrue: [
								contents add: aWord.
								"Transcript show: '|',aWord, '|';cr."
							].
						].
					].
				].
				aLine _ aFile upTo: Character cr.
				aFile next.
				bar value: aFile position.
			].
		].
	aFile close.! !

!ScrabbleDictionary methodsFor: 'initialization' stamp: 'JMV 7/24/1999 09:21'!
name: aString language: aLanguage
	"Inicialize an instance"

	name _ aString.
	language _ aLanguage.
	contents _ OrderedCollection new! !


ObjectWithID subclass: #ScrabbleGame
	instanceVariableNames: 'board players bag dictionary playerScores playerTiles actualTurn playerQtyWanted maxTurnTime maxGameTime joinLimitTime playerStatus qtyThatPassed status '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ScrabbleGame methodsFor: 'initialize' stamp: 'JMV 7/25/1999 15:17'!
dictionary: aScrabbleDictionary playerQtyWanted: aNumber maxTurnTime: turnMinutes maxGameTime: gameMinutes joinLimitTime: aTime
	"Game inicialization on its creation "
	
	dictionary _ aScrabbleDictionary.
	playerQtyWanted _ aNumber.
	maxTurnTime _ turnMinutes.
	maxGameTime _ gameMinutes.
	joinLimitTime _ aTime.
	players _ OrderedCollection new.
	playerScores _ Dictionary new.
	playerTiles _ Dictionary new.
	playerStatus _ Dictionary new.
	status _ #openForJoin.! !


!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/16/1999 10:42'!
actualTurnPlayer

	^ players at: actualTurn! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/14/1999 23:22'!
board

	^ board! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/14/1999 21:31'!
dictionary

	^ dictionary! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/24/1999 17:44'!
isOpenForJoin

	^ (status = #openForJoin) & 
		(self playerQty < self playerQtyWanted)! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/13/1999 21:55'!
joinLimitTime

	^ joinLimitTime! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/25/1999 15:29'!
playerQty

	^ status = #openForJoin ifTrue: [
		players size ]
	ifFalse: [
		(players select: [ :j | (playerStatus at: j) = #active ]) size ].! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/13/1999 21:55'!
playerQtyWanted

	^ playerQtyWanted! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/13/1999 21:48'!
status

	^ status! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/25/1999 13:14'!
status: aSymbol

	^ status _ aSymbol! !

!ScrabbleGame methodsFor: 'accessing' stamp: 'JMV 7/15/1999 21:42'!
tilesOfPlayer: aPerson

	^ playerTiles at: aPerson! !


!ScrabbleGame methodsFor: 'validations' stamp: 'JMV 7/16/1999 17:22'!
checkPlay: playData

	| words answer |

	(self board areAlignedAndConnected: playData) ifTrue:[
		answer _ true.
		words _ self board formedWords: playData.
		words do: [:eachWord |
			(self dictionary isAValidWord: eachWord) ifFalse: [
				answer _ false ] ]
	] ifFalse: [
		answer _ false ].
	^ answer! !


!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/17/1999 00:34'!
fillPlayerDeck

	| qty tiles |
	qty _ 7 - (self tilesOfPlayer: self actualTurnPlayer) size.
	tiles _ (bag removeTiles: qty).
	(self tilesOfPlayer: self actualTurnPlayer) addAll: tiles.
	tiles do: [ :f |
		ClientManager current addVisibleByClients: f ].! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/16/1999 18:42'!
removeFromPlayerDeck: playData

	| tile |
	1 to: playData size / 3 do: [ :i |
		tile _ ClientManager current convertToObject: (playData at: i*3-2).
		(self tilesOfPlayer: self actualTurnPlayer) remove: tile ].! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/17/1999 11:14'!
removeFromPlayerDeckExchanged: playData

	| tile |
	1 to: playData size do: [ :i |
		tile _ ClientManager current convertToObject: (playData at: i).
		(self tilesOfPlayer: self actualTurnPlayer) remove: tile ].! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/17/1999 12:57'!
scores

	| result |
	result _ ''.
	players do: [ :each |
		result _ result, 
			each nickName, ' ', (playerScores at: each) asString,'\' withCRs. ].
	^ result.! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/16/1999 19:11'!
tileWasMoved: aScrabbleTileID by: aPersonID x: xString y: yString

	self signalEvent: #tileWasMoved withArguments: 
		(Array with: aScrabbleTileID 
			with: aPersonID
			with: xString
			with: yString).! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/16/1999 22:09'!
tileWasRemoved: aScrabbleTileID by: aPersonID

	self signalEvent: #tileWasRemoved withArguments: 
		(Array with: aScrabbleTileID with: aPersonID).! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/16/1999 22:48'!
updateBoard: playData

	| x y tile |
	1 to: playData size / 3 do: [ :i |
		x _ (playData at: i*3-1) asNumber.
		y _ (playData at: i*3) asNumber.
		tile _ ClientManager current convertToObject: (playData at: i*3-2).
		(self board boxAtX: x y: y) tile: tile.
	].! !

!ScrabbleGame methodsFor: 'game detalles' stamp: 'JMV 7/17/1999 13:35'!
updateScore: playData

	| score |
	score _ playerScores at: self actualTurnPlayer.
	score _ score + (self board scoreForPlay: playData).
	playerScores at: self actualTurnPlayer put: score.! !


!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/25/1999 15:29'!
adjustNextTurn

	actualTurn isNil ifTrue: [
		actualTurn _ 1 ]
	ifFalse: [
		actualTurn _ (actualTurn rem: self playerQty) + 1.
		[ (playerStatus at: (players at: actualTurn)) = #active ] whileFalse: [
			actualTurn _ (actualTurn rem: self playerQty) + 1 ].
	].

	qtyThatPassed = self playerQty ifTrue: [
		self endGame ].

	^ actualTurn! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/24/1999 20:39'!
cancelGame
	""

	VirtualPlayroom current removeGame: self.
	self signalEvent: #gameCancelled withArguments: #().! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/24/1999 13:12'!
changeTiles: playData

	| anArray |
	anArray _ playData substrings.
	anArray _ anArray copyFrom: 2 to: anArray size.
	self removeFromPlayerDeckExchanged: anArray.
	self fillPlayerDeck.
	self signalEvent: #exchangedTiles withArguments: 
		(Array with: self actualTurnPlayer objectID).
	qtyThatPassed _ 0.
	self adjustNextTurn.
	self signalEvent: #nextTurn withArguments: 
		(Array with: self actualTurnPlayer objectID with: self scores).
	"The just sent events are efectively sent AFTER the end of this method"
	^ 'valid'! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/24/1999 13:14'!
confirmPlay: playData

	| anArray answer |
	anArray _ playData substrings.
	anArray _ anArray copyFrom: 2 to: anArray size.

	(self checkPlay: anArray) ifTrue:[
		self removeFromPlayerDeck: anArray.
		self fillPlayerDeck.
		self updateBoard: anArray.
		self updateScore: anArray.
		"Client: Take new tiles, lock the played ones "
		self signalEvent: #confirmedTiles withArguments: 
			(Array with: self actualTurnPlayer objectID).
		answer _ 'valid' ]
	ifFalse: [
		"Client: Take tiles back to the deck"
		self signalEvent: #notConfirmedTiles withArguments: 
			(Array with: self actualTurnPlayer objectID).
		answer _ 'invalid' ].
	qtyThatPassed _ 0.
	self adjustNextTurn.
	self signalEvent: #nextTurn withArguments: 
		(Array with: self actualTurnPlayer objectID with: self scores).
	"The just sent events are efectively sent AFTER the end of this method"
	^ answer! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/24/1999 13:43'!
endGame

	| score winner |
	score _ -1.
	ClientManager current removeVisibleByClients: board.
	players do: [ :each |
		((playerStatus at: each) = #active) & 
		((playerScores at: each) > score) ifTrue: [
			score _ playerScores at: each.
			winner _ each ].
		(playerTiles at: each) do: [ :f |
			ClientManager current removeVisibleByClients: f ] ].
	board tiles do: [ :f |
		ClientManager current removeVisibleByClients: f ].

	VirtualPlayroom current removeGame: self.
	self signalEvent: #gameEnded withArguments: (Array with: winner nickName).! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/7/1999 20:42'!
giveUp: aPerson! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/25/1999 15:19'!
join: aPerson

	players add: aPerson.
	playerStatus at: aPerson put: #joined.! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/24/1999 13:12'!
pass

	qtyThatPassed _ qtyThatPassed + 1.
	self adjustNextTurn.
	self signalEvent: #nextTurn withArguments: 
		(Array with: self actualTurnPlayer objectID with: self scores).
	"The just sent events are efectively sent AFTER the end of this method"
	^ 'valid'! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 3/26/2000 11:28'!
startIfAppropiate
	"If all the players are in, or time limit passed"

	| tiles |
	( (status = #openForJoin) & 
		((self playerQty = self playerQtyWanted) |
			(Time now >= self joinLimitTime)) ) ifTrue: [
		self playerQty >= 2 ifFalse: [
			self cancelGame.]
		ifTrue: [
			board _ ScrabbleBoard newForPlayerQty: self playerQty.
			ClientManager current addVisibleByClients: board.
			bag _ ScrabbleTilesBag newForPlayerQty: self playerQty dictionary: self dictionary.
			actualTurn _ 1.
			players do: [ :each |
				playerScores at: each put: 0.
				(status = #openForJoin) ifTrue: [
					playerStatus at: each put: #active ].
				tiles _ bag removeTiles: 7.
				playerTiles at: each put: tiles.
				tiles do: [ :f |
					ClientManager current addVisibleByClients: f ].
			].
			qtyThatPassed _ 0. 
			status _ #started.
			self signalEvent: #gameStarted withArguments: 
				(Array with: self actualTurnPlayer objectID).
		].
	].! !

!ScrabbleGame methodsFor: 'game' stamp: 'JMV 7/24/1999 11:35'!
unJoin: aPerson

	players remove: aPerson! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScrabbleGame class
	instanceVariableNames: ''!

!ScrabbleGame class methodsFor: 'instance creation' stamp: 'JMV 7/13/1999 19:36'!
newScrabbleDictionary: aScrabbleDictionary playerQtyWanted: aNumber maxTurnTime: turnMinutes maxGameTime: gameMinutes joinLimitTime: aTime

	^ self new dictionary: aScrabbleDictionary 
		playerQtyWanted: aNumber 
		maxTurnTime: turnMinutes 
		maxGameTime: gameMinutes 
		joinLimitTime: aTime; 
	yourself! !


ObjectWithID subclass: #ScrabblePerson
	instanceVariableNames: 'nickName password '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ScrabblePerson methodsFor: 'initialize' stamp: 'JMV 7/9/1999 19:46'!
nickName: aString password: otherString
	"Inicialize a person"

	nickName _ aString.
	password _ otherString.! !


!ScrabblePerson methodsFor: 'accesing' stamp: 'JMV 7/9/1999 19:44'!
nickName

	^ nickName! !

!ScrabblePerson methodsFor: 'accesing' stamp: 'JMV 7/7/1999 20:18'!
password

	^ password! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScrabblePerson class
	instanceVariableNames: ''!

!ScrabblePerson class methodsFor: 'instance creation' stamp: 'JMV 7/9/1999 19:46'!
newNickName: aString password: otherString

	^ self new nickName: aString password: otherString! !


ObjectWithID subclass: #ScrabbleTile
	instanceVariableNames: 'letter score '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ScrabbleTile methodsFor: 'accessing' stamp: 'JMV 7/15/1999 22:07'!
data

	^ self letter asString, self score asString.! !

!ScrabbleTile methodsFor: 'accessing' stamp: 'JMV 7/15/1999 20:18'!
letter

	^ letter! !

!ScrabbleTile methodsFor: 'accessing' stamp: 'JMV 7/15/1999 20:18'!
letter: aCharacter

	^ letter _ aCharacter! !

!ScrabbleTile methodsFor: 'accessing' stamp: 'JMV 7/16/1999 20:11'!
letterString: aString

	^ letter _ aString first! !

!ScrabbleTile methodsFor: 'accessing' stamp: 'JMV 7/15/1999 20:18'!
score

	^score! !

!ScrabbleTile methodsFor: 'accessing' stamp: 'JMV 7/15/1999 20:19'!
score: aNumber

	^ score _ aNumber! !


ObjectWithID subclass: #ScrabbleTilesBag
	instanceVariableNames: 'tiles '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!ScrabbleTilesBag methodsFor: 'accessing' stamp: 'JMV 7/15/1999 21:34'!
removeTiles: aNumber
	"Remove and answer aNumber tiles, or oll the existing if not enough "

	| result |
	result _ OrderedCollection new.
	aNumber timesRepeat: [
		result add: (tiles remove: tiles atRandom) ].
	^ result! !


!ScrabbleTilesBag methodsFor: 'initialize' stamp: 'JMV 4/15/2000 10:46'!
playerQty: aNumber dictionary: aScrabbleDictionary

	| anArray letter qty score |
	tiles _ OrderedCollection new.
	anArray _ self class lettersQtyAndScoresForDictionary: aScrabbleDictionary.
	1 to: anArray size / 3 do: [ :i |
		letter _ anArray at: i*3-2.
		qty _ anArray at: i*3-1.
		aNumber > 4 ifTrue: [ qty _ qty * aNumber // 4 ].
		score _ anArray at: i*3.
		qty timesRepeat: [
			tiles add: ( ScrabbleTile new
				letter: letter;
				score: score;
				yourself) ] ].

	"Add blanks"
	qty _ 2.
	aNumber > 4 ifTrue: [ qty _ qty * aNumber // 4 ].
	qty timesRepeat: [
		tiles add: ( ScrabbleTile new
			letter: $ ;
			score: 0;
			yourself) ].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScrabbleTilesBag class
	instanceVariableNames: ''!

!ScrabbleTilesBag class methodsFor: 'instance creation' stamp: 'JMV 4/15/2000 10:48'!
newForPlayerQty: aNumber dictionary: aScrabbleDictionary

	^ self new playerQty: aNumber dictionary: aScrabbleDictionary.! !


!ScrabbleTilesBag class methodsFor: 'inicialization defaults' stamp: 'JMV 4/15/2000 10:57'!
lettersQtyAndScoresForDictionary: aScrabbleDictionary
	"Default for 4 players"

	^aScrabbleDictionary language name = 'Espaol' ifTrue: [
		#($A 9 1 $B 2 3 $C 2 3 $D 4 2 $E 10 1 $F 2 4 $G 3 2 $H 2 4 $I 8 1 $J 2 8 $K 1 5 $L 3 1 $M 2 3 $N 4 1 $ 2 2 $O 7 1 $P 2 3 $Q 3 10 $R 6 1 $S 4 1 $T 6 1 $U 4 1 $V 2 4 $W 1 1 $X 1 8 $Y 2 4 $Z 1 10) ]
	ifFalse: [
		#($A 9 1 $B 2 3 $C 2 3 $D 4 2 $E 10 1 $F 2 4 $G 3 2 $H 2 4 $I 8 1 $J 2 8 $K 1 5 $L 3 1 $M 2 3 $N 4 1 $O 7 1 $P 2 3 $Q 3 10 $R 6 1 $S 4 1 $T 6 1 $U 4 1 $V 2 4 $W 1 1 $X 1 8 $Y 2 4 $Z 1 10) ]! !


Object subclass: #VirtualPlayroom
	instanceVariableNames: 'languages persons games dictionaries '
	classVariableNames: 'Current '
	poolDictionaries: ''
	category: 'Scrabble-TheGame'!

!VirtualPlayroom methodsFor: 'processing' stamp: 'JMV 3/26/2000 11:03'!
processOneCycle

	"Games"
	games do: [ :each |
		each startIfAppropiate ].! !


!VirtualPlayroom methodsFor: 'services' stamp: 'JMV 7/11/1999 21:51'!
dictionariesFor: aLanguage

	| answer |
	answer _ dictionaries select: [ :each |
		each language = aLanguage ].
	answer isEmpty ifTrue: [
		answer _ nil ].
	^ answer.
	! !

!VirtualPlayroom methodsFor: 'services' stamp: 'JMV 7/11/1999 22:37'!
languageNames

	^ languages collect: [ :each | each name ]! !

!VirtualPlayroom methodsFor: 'services' stamp: 'JMV 7/11/1999 21:49'!
languages

	^ languages! !

!VirtualPlayroom methodsFor: 'services' stamp: 'JMV 7/11/1999 22:38'!
scrabbleDictionaryNamesFor: aLanguageName

	| answer |
	answer _ (dictionaries select: [ :each |
		each language name = aLanguageName ])
			collect: [:each | each name].
	answer isEmpty ifTrue: [
		answer _ nil ].
	^ answer.
	! !

!VirtualPlayroom methodsFor: 'services' stamp: 'JMV 7/13/1999 20:17'!
validateLogin: aName password: aPassword
	"Validate login. If user does not exist, add as new."

	| aPerson |
	aPerson _ persons 
		detect: [ :somePerson | somePerson nickName = aName ] 
		ifNone: [ nil ].
	(aPerson notNil and: [ (aPerson password = aPassword) not ]) ifTrue: [
		^ 'invalid password' ].
	aPerson isNil ifTrue: [
		aPerson _ ScrabblePerson newNickName: aName password: aPassword.
		self addPersona: aPerson ].
	^ aPerson objectID.! !


!VirtualPlayroom methodsFor: 'games' stamp: 'JMV 7/13/1999 20:26'!
createGameWithDictionary: aDiccName playerQty: aStr maxTurnTime: playMinutesStr maxGameTime: gameMinutesStr joinLimitTime: aTimeStr
	"Create a new game"

	| newGame |
	newGame := ScrabbleGame newScrabbleDictionary: (dictionaries detect: [ :d | d name = aDiccName ])
		playerQtyWanted: aStr asNumber
		maxTurnTime: playMinutesStr asNumber
		maxGameTime: gameMinutesStr asNumber
		joinLimitTime: aTimeStr asTime.
	self addGame: newGame.
	^ newGame objectID.! !

!VirtualPlayroom methodsFor: 'games' stamp: 'JMV 7/24/1999 17:43'!
gamesOpenForJoin

	| answer |
	answer _ OrderedCollection new.
	games doWithIndex: [ :each :i | 
		(each isOpenForJoin) ifTrue: [
			answer add: each objectID.
			answer add: 
				i asString,
				'. Players: ', each playerQtyWanted asString, 
				'. Starts: ', each joinLimitTime asString ] ].
	^ answer! !


!VirtualPlayroom methodsFor: 'accessing' stamp: 'JMV 7/13/1999 20:48'!
addGame: aGame

	games add: aGame.
	ClientManager current addVisibleByClients: aGame.! !

!VirtualPlayroom methodsFor: 'accessing' stamp: 'JMV 7/13/1999 20:48'!
addPersona: aPerson

	persons add: aPerson.
	ClientManager current addVisibleByClients: aPerson.! !

!VirtualPlayroom methodsFor: 'accessing' stamp: 'JMV 7/16/1999 16:40'!
dictionaries

	^ dictionaries! !

!VirtualPlayroom methodsFor: 'accessing' stamp: 'JMV 7/24/1999 11:52'!
removeGame: aGame

	games remove: aGame.
	ClientManager current removeVisibleByClients: aGame.! !


!VirtualPlayroom methodsFor: 'initialization' stamp: 'JMV 3/26/2000 11:03'!
initialize

	languages _ OrderedCollection new.
	dictionaries _ OrderedCollection new.
	persons _ OrderedCollection new.
	games _ OrderedCollection new.
	self initializeLanguagesAndScrabbleDictionaries! !

!VirtualPlayroom methodsFor: 'initialization' stamp: 'JMV 3/26/2000 16:07'!
initializeLanguagesAndScrabbleDictionaries
	"Inicialize an instance"

	| aLanguage aScrabbleDictionary |

	aLanguage _ Language new name: 'English'; yourself.
	languages add: aLanguage.
	aScrabbleDictionary _ ScrabbleDictionary new name: aLanguage name language: aLanguage.
	aScrabbleDictionary importEnglishPartFromIDP: 'spanish.txt'.
	aScrabbleDictionary importFrom: 'eng.dat'.
	aScrabbleDictionary importFrom: 'sowpods.html'.
	dictionaries add: aScrabbleDictionary.

	aLanguage _ Language new name: 'Espaol'; yourself.
	languages add: aLanguage.
	aScrabbleDictionary _ ScrabbleDictionary new name: aLanguage name language: aLanguage.
	aScrabbleDictionary importNonEnglishPartFromIDP: 'spanish.txt'.
	aScrabbleDictionary importFromDAT: 'spn.dat'.
	dictionaries add: aScrabbleDictionary.

	aLanguage _ Language new name: 'Portugueis'; yourself.
	languages add: aLanguage.
	aScrabbleDictionary _ ScrabbleDictionary new name: aLanguage name language: aLanguage.
	aScrabbleDictionary importNonEnglishPartFromIDP: 'portugue.txt'.
	dictionaries add: aScrabbleDictionary.

	aLanguage _ Language new name: 'Italiano'; yourself.
	languages add: aLanguage.
	aScrabbleDictionary _ ScrabbleDictionary new name: aLanguage name language: aLanguage.
	aScrabbleDictionary importNonEnglishPartFromIDP: 'italian.txt'.
	dictionaries add: aScrabbleDictionary.

	aLanguage _ Language new name: 'Francaise'; yourself.
	languages add: aLanguage.
	aScrabbleDictionary _ ScrabbleDictionary new name: aLanguage name language: aLanguage.
	aScrabbleDictionary importNonEnglishPartFromIDP: 'french.txt'.
	dictionaries add: aScrabbleDictionary.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

VirtualPlayroom class
	instanceVariableNames: ''!

!VirtualPlayroom class methodsFor: 'instance creation' stamp: 'JMV 7/11/1999 21:40'!
current
	"Answer the active playroom"

	Current isNil ifTrue: [
		Current _ super new initialize ].
	^ Current! !
